/*                                              */
/*         Virtual Pascal for OS/2 v1.10        */
/*         Build all TOT v1.10 examples         */
/*         (C) 1996-97 fPrint UK Ltd            */

Signal On Halt Name UserBreak

Say "Build TOT v1.10 examples for VP/2                   (C) 1996 fPrint UK Ltd"
Say

/* The following line should specify the base directory of VP/2 */
Os2Env = 'OS2ENVIRONMENT'
VP = VALUE('VPBASE',,Os2Env)
if VP = '' then
  do
    Say "The VPBASE environment variable does not point to the base VP/2"
    Say "directory.  Please specify base directory (eq C:\VP11):"
    Pull VP
  end

rcFile = stream( VP'\BIN\VPC.EXE', 'c', 'query exists' )
if rcFile = "" then
  do
    Say "Virtual Pascal for OS/2 cannot be found at the location"
    Say "specified: "VP
    Say
    Say "Please correct this error and re-try the operation"
    Signal UserBreak
  end

/*Initialisation */

Apps = 0

Address "CMD.EXE"
StartDir = DIRECTORY()

Lib = value('LIB',,Os2Env)
Lib = value('LIB',VP'\lib;'Lib, Os2Env )

/* Parse command line */

Arg . "/"Options

BASED = TRUE
DEBUG = False
If POS( "B", Options ) > 0 then
  BASED = False
If POS( "D", Options ) > 0 then
  DEBUG = True

/* Build the source code */

'@MD OUT >nul 2>&1'

Say "Building all TOT examples"

Call App VIO  demo TBrowse     "TOT Browser Demo"
Call App VIO  demo Tele        "Telephone Labels demo"
Call App VIO  demo TotDemo     "TOT Comprehensive Demo"

Call App VIO  demo DemBr1      "Demo Browse 1"
Call App VIO  demo DemBr2      "Demo Browse 2"
Call App VIO  demo DemBr3      "Demo Browse 3"
Call App VIO  demo DemBr4      "Demo Browse 4"
Call App VIO  demo DemBr5      "Demo Browse 5"
Call App VIO  demo DemBx1      "Demo Box 1"
Call App VIO  demo DemBx2      "Demo Box 2"
Call App VIO  demo DemBx3      "Demo Box 3"
Call App VIO  demo DemCu1      "Demo Cursor 1"
Call App VIO  demo DemDr1      "Demo Directory 1"
Call App VIO  demo DemDr2      "Demo Directory 2"
Call App VIO  demo DemDr3      "Demo Directory 3"
Call App VIO  demo DemDr4      "Demo Directory 4"
Call App VIO  demo DemDr5      "Demo Directory 5"
Call App VIO  demo DemDr6      "Demo Directory 6"
Call App VIO  demo DemDr7      "Demo Directory 7"
Call App VIO  demo DemDt1      "Demo Date 1"
Call App VIO  demo DemDt2      "Demo Date 2"
Call App VIO  demo DemEnv1     "Demo Pull down menus and HotSpots"
Call App VIO  demo DemEx1      "Demo Execute program 1"
Call App VIO  demo DemEx2      "Demo Execute program 2"
Call App VIO  demo DemFs1      "Demo Fast Screens 1"
Call App VIO  demo DemFs2      "Demo Fast Screens 2"
Call App VIO  demo DemIn1      "Demo Input 1"
Call App VIO  demo DemIn2      "Demo Input 2"
Call App VIO  demo DemIn3      "Demo Input 3"
Call App VIO  demo DemIn4      "Demo Input 4"
Call App VIO  demo DemIO1      "Demo Input Fields 1"
Call App VIO  demo DemIO2      "Demo Input Fields 2"
Call App VIO  demo DemIO3      "Demo Input Fields 3"
Call App VIO  demo DemIO4      "Demo Input Fields 4"
Call App VIO  demo DemIO5      "Demo Input Fields 5"
Call App VIO  demo DemIO6      "Demo Input Fields 6"
Call App VIO  demo DemIO7      "Demo Input Fields 7"
Call App VIO  demo DemIO8      "Demo Input Fields 8"
Call App VIO  demo DemIO9      "Demo Input Fields 9"
Call App VIO  demo DemIO10     "Demo Input Fields 10"
Call App VIO  demo DemIO11     "Demo Input Fields 11"
Call App VIO  demo DemIO12     "Demo Input Fields 12"
Call App VIO  demo DemIO13     "Demo Input Fields 13"
Call App VIO  demo DemIO14     "Demo Input Fields 14"
Call App VIO  demo DemIO15     "Demo Input Fields 15"
Call App VIO  demo DemIO16     "Demo Input Fields 16"
Call App VIO  demo DemIO17     "Demo Input Fields 17"
Call App VIO  demo DemIO18     "Demo Input Fields 18"
Call App VIO  demo DemIO19     "Demo Input Fields 19"
Call App VIO  demo DemIO20     "Demo Input Fields 20"
Call App VIO  demo DemIO21     "Demo Input Fields 21"
Call App VIO  demo DemIO22     "Demo Input Fields 22"
Call App VIO  demo DemIO23     "Demo Input Fields 23"
Call App VIO  demo DemIO24     "Demo Input Fields 24"
Call App VIO  demo DemLk1      "Demo Linked List 1"
Call App VIO  demo DemLk2      "Demo Linked List 2"
Call App VIO  demo DemLs1      "Demo List 1"
Call App VIO  demo DemLs2      "Demo List 2"
Call App VIO  demo DemLs3      "Demo List 3"
Call App VIO  demo DemLs4      "Demo List 4"
Call App VIO  demo DemLs5      "Demo List 5"
Call App VIO  demo DemLs6      "Demo List 6"
Call App VIO  demo DemLs7      "Demo List 7"
Call App VIO  demo DemLs8      "Demo List 8"
Call App VIO  demo DemLs9      "Demo List 9"
Call App VIO  demo DemMn1      "Demo Menu 1"
Call App VIO  demo DemMn2      "Demo Menu 2"
Call App VIO  demo DemMn3      "Demo Menu 3"
Call App VIO  demo DemMn4      "Demo Menu 4"
Call App VIO  demo DemMn5      "Demo Menu 5"
Call App VIO  demo DemMn6      "Demo Menu 6"
Call App VIO  demo DemMn7      "Demo Menu 7"
Call App VIO  demo DemMn8      "Demo Menu 8"
Call App VIO  demo DemMn9      "Demo Menu 9"
Call App VIO  demo DemMn9A     "Demo Menu 9A"
Call App VIO  demo DemMn9A     "Demo Menu 9A"
Call App VIO  demo DemMs1      "Demo Message 1"
Call App VIO  demo DemMs2      "Demo Message 2"
Call App VIO  demo DemMs3      "Demo Message 3"
Call App VIO  demo DemMs4      "Demo Message 4"
Call App VIO  demo DemMs5      "Demo Message 5"
Call App VIO  demo DemMs6      "Demo Message 6"
Call App VIO  demo DemMs7      "Demo Message 7"
Call App VIO  demo DemMs8      "Demo Message 8"
Call App VIO  demo DemSc1      "Demo Scroller 1"
Call App VIO  demo DemSh1      "Demo Shadow 1"
Call App VIO  demo DemSt1      "Demo Strings 1"
Call App VIO  demo DemSt2      "Demo Strings 2"
Call App VIO  demo DemSt3      "Demo Strings 3"
Call App VIO  demo DemSy1      "Demo System 1"
Call App VIO  demo DemVi1      "Demo Virtual 1"
Call App VIO  demo DemWi1      "Demo Window 1"
Call App VIO  demo DemWi2      "Demo Window 2"
Call App VIO  demo DemWi3      "Demo Window 3"
Call App VIO  demo DemWi4      "Demo Window 4"
Call App VIO  demo ExtDem3     "Extended Demo 3"
Call App VIO  demo ExtDem4     "Extended Demo 4"
Call App VIO  demo ExtDem5     "Extended Demo 5"
Call App VIO  demo ExtDem6     "Extended Demo 6"
Call App VIO  demo ExtDem7     "Extended Demo 7"
Call App VIO  demo ExtDem8     "Extended Demo 8"

Say "TOT examples succesfully compiled"
Signal stop

App:
  Arg AppType DirName AppName Description
  rc = stream( DirName'\'AppName'.EXE', 'c', 'query exists' )
  if rc \= '' then
    return

  Say
  Say '>>'Description
  '@del out\'AppName'.exe >nul 2>&1'
  VP'\bin\vpc @'StartDir'\vpc.cfg 'DirName'\'AppName
  if rc \= 0 then
    do
      Say "ERROR! Compile failed"
      signal Stop
    end

  '@del 'DirName'\'AppName'.Exe >nul 2>&1'
  '@move out\'AppName'.exe 'DirName' >nul 2>&1'
  '@del out\'AppName'.* >nul 2>&1'

  Apps = Apps + 1
return

Userbreak:
Say
Say "  Install process interrupted!"

Stop:
Say
Say "  Total : "Apps" example programs compiled"
Say
rc = DIRECTORY( StartDir )

