{               Copyright 1991 TechnoJock Software, Inc.               }
{                          All Rights Reserved                         }
{                         Restricted by License                        }

{                             Build # 1.00                             }

Unit totINPUT;
{$I TOTFLAGS.INC}

{
 Development Notes:

}


INTERFACE

uses
   {$IFDEF OS2}
   Os2Def, Os2Base, VPUtils, Os2Mutex,
   {$ENDIF}
   Use32, DOS,CRT;

Const
    StuffBufferSize = 30;

Type

  InputIdleProc    = procedure;
  InputPressedProc = procedure(var W:word);
  CharProc         = procedure(W:word);
  CaseFunc         = function(Ch:char):char;
  CharSet = set of char;
  tButtons = ( LeftButton, RightButton, CenterButton );
  ButtonState = record
    Count : Array[0..2] of Word;
    LastX : Word;
    LastY : Word;
  end;

pAlphabetOBJ = ^AlphabetOBJ;
AlphabetOBJ = object
   vUpper: CharSet;
   vLower: CharSet;
   vPunctuation: CharSet;
   vUpCaseFunc: CaseFunc;
   vLoCaseFunc: CaseFunc;
   {methods...}
   constructor Init;
   procedure   AssignUpCaseFunc(Func:caseFunc);
   procedure   AssignLoCaseFunc(Func:caseFunc);
   procedure   SetUpper(Letters:CharSet);
   procedure   SetLower(Letters:CharSet);
   procedure   SetPunctuation(Letters:CharSet);
   function    IsUpper(K:word): boolean;
   function    IsLower(K:word): boolean;
   function    IsLetter(K:word): boolean;
   function    IsPunctuation(K:word): boolean;
   function    GetUpCase(Ch:char):char;
   function    GetLoCase(Ch:char):char;
   destructor  Done;
end; {AlphabetOBJ}

pMouseOBJ = ^MouseOBJ;
MouseOBJ = object
   vInstalled: boolean;   {is the system equipped with a mouse}
   vButtons: byte;        {how many buttons on mouse}
   vLeftHanded: boolean;  {is right button Enter?}
   vIntr: integer;        {mouse interrupt number}
   vVisible: boolean;     {is mouse cursor visible?}
   {$IFDEF OS2}
   mouHandle    : SmallWord;  // OS/2 Mouse Handle
   mouX         : Longint;           // Current X coordinate of mouse
   mouY         : Longint;           // Current Y coordinate of mouse
   ProtectArea  : NoPtrRect;         // Current mouse button state
   ButtonState  : Set of tButtons;
   ReleaseCount : ButtonState;
   PressCount   : ButtonState;
   mouMutex     : tMutexSem;         // Exclusivity flag
   ConfineX1    : Longint;           // Mouse limit
   ConfineX2    : Longint;           // Mouse limit
   ConfineY1    : Longint;           // Mouse limit
   ConfineY2    : Longint;           // Mouse limit
   tid_Mouse    : TID;               // Mouse Thread ID
   {$ENDIF}
   {methods}
   constructor Init;
   procedure   Reset;
   function    Installed:boolean;
   procedure   CheckInstalled;
   procedure   Show;
   procedure   Hide;
   procedure   Move(X,Y : integer);
   procedure   Confine(X1,Y1,X2,Y2:integer);
   function    Released(Button: integer; var X,Y: byte): byte;
   function    Pressed(Button: integer; var X,Y: byte): byte;
   function    InZone(X1,Y1,X2,Y2: byte):boolean;
   procedure   Location(var X,Y : byte);
   procedure   Status(var L,C,R:boolean; var X,Y : byte);
   procedure   WaitForRelease;
   function    Visible: boolean;
   procedure   SetMouseCursorStyle(OrdChar,Attr:byte);
   procedure   SetLeft(On:boolean);
   function    GetButtons: byte;
   destructor  Done;
end; {MouseOBJ}

pKeyOBJ = ^KeyOBJ;
KeyOBJ = object
   vMouseMethod: byte;        {0-no mouse, 1-cursor emulation, 2-freefloating mouse}
   vBuffer: array[1..StuffBufferSize] of word;
   vBufferHead: word;         {next character from buffer}
   vBufferTail:word;          {last valid character in buffer}
   vLastkey: word;            {the last key pressed}
   vLastX:byte;               {location of mouse when button pressed}
   vLastY:byte;               {                -"-                  }
   vClick: boolean;           {click after every keypress?}
   vHorizSensitivity: byte;   {no of characters}
   vVertSensitivity: byte;    {      -"-       }
   vWaitForDouble: boolean;
   vIdleHook: InputIdleProc;
   vPressedHook: InputPressedProc;
   vExtended : boolean;       {is it an extended keyboard}
   vButtons : byte;
   {methods...}
   constructor Init;
   procedure   AssignIdleHook(PassedProc: InputIdleProc);
   procedure   AssignPressedHook(PassedProc: InputPressedProc);
   function    Extended: boolean;
   procedure   SetCaps(On:boolean);
   procedure   SetNum(On:boolean);
   procedure   SetScroll(On:boolean);
   function    GetCaps:boolean;
   function    GetNum:boolean;
   function    GetScroll:boolean;
   procedure   SetRepeatRate(Delay,Rate:byte);
   procedure   SetFast;
   procedure   SetSlow;
   procedure   SetMouseMethod(Method:byte);
   procedure   SetClick(On: boolean);
   procedure   SetDouble(On:boolean);
   function    GetDouble:boolean;
   procedure   Click;
   procedure   SetHoriz(Sensitivity:byte);
   procedure   SetVert(Sensitivity:byte);
   procedure   GetInput;
   function    LastKey: word;
   function    LastChar: char;
   function    LastX: byte;
   function    LastY: byte;
   function    GetKey: word;
   procedure   FlushBuffer;
   procedure   StuffBuffer(W:word);
   procedure   StuffBufferStr(Str:string);
   function    Keypressed: boolean;
   procedure   DelayKey(Mills:longint);
   function    AltPressed:boolean;
   function    CtrlPressed:boolean;
   function    LeftShiftPressed: boolean;
   function    RightShiftPressed: boolean;
   function    ShiftPressed: boolean;
   destructor  Done;
end; {KeyOBJ}

procedure NoInputIdleHook;
procedure NoInputPressedHook(var W:word);
function  Altkey(K: word): word;
procedure inputINIT;

VAR
   AlphabetTOT: ^AlphabetOBJ;
   Mouse: MouseOBJ;
   Key:   KeyOBJ;

IMPLEMENTATION

{$IFNDEF OS2}
var
   KeyStatusBits : word absolute $0040:$0017;
{$ENDIF}

{|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||}
{                                                               }
{     U N I T   P R O C E D U R E S   &   F U N C T I O N S     }
{                                                               }
{|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||}

{$F+}
 procedure NoInputIdleHook;
 {empty procs}
 begin end; {NoInputIdleHook}

{$IFDEF OS2}
 procedure Os2IdleHook;
 begin
   DosSleep( 31 );
 end;
{$ENDIF}

 procedure NoInputPressedHook(var W:word);
 {empty procs}
 begin end; {NoInputPressedHook}

 function EnglishUpCase(Ch:char):char;
 {}
 begin
    EnglishUpCase := upcase(Ch);
 end; {EnglishUpCase}
(*
 inline($58/$3C/$61/$72/$39/$3C/$7A/$76/$33/$3C/$84/$75/$02/$B0/$8E
 /$3C/$94/$75/$02/$B0/$99/$3C/$81/$75/$02/$B0/$9A
 /$3C/$87/$75/$02/$B0/$80/$3C/$86/$75/$02/$B0/$BF
 /$3C/$82/$75/$02/$B0/$90/$3C/$91/$75/$02/$B0/$92
 /$3C/$A4/$75/$02/$B0/$A5/$EB/03/90/$2C/$20);
*)
 function EnglishLoCase(Ch:char):char;
 {}
 begin
   if Ch in ['A'..'Z'] then
      EnglishLoCase := chr(ord(Ch) + 32)
   else
      EnglishLoCase := Ch;
 end; {EnglishLoCase}
 (*
 inline($58/$3C/$41/$72/$39/$3C/$5A/$76/$33/$3C/$8E/$75/$02/$B0/$B4
 /$3C/$99/$75/$02/$B0/$94/$3C/$9A/$75/$02/$B0/$81
 /$3C/$8D/$75/$02/$B0/$87/$3C/$8F/$75/$02/$B0/$86
 /$3C/$9D/$75/$02/$B0/$82/$3C/$92/$75/$02/$B0/$91
 /$3C/$A5/$75/$02/$B0/$A4/$EB/03/90/$04/$20);
 *)
{$F-}

function Altkey(K: word): word;
{returns the Alt keycode equivalent of a number or letter}
var AK: word;
begin
   Case K of
      65:AK:=286; 66:AK:=304; 67:AK:=302; 68:AK:=288; 69:AK:=274; 70:AK:=289;
      71:AK:=290; 72:AK:=291; 73:AK:=279; 74:AK:=292; 75:AK:=293; 76:AK:=294;
      77:AK:=306; 78:AK:=305; 79:AK:=280; 80:AK:=281; 81:AK:=272; 82:AK:=275;
      83:AK:=287; 84:AK:=276; 85:AK:=278; 86:AK:=303; 87:AK:=273; 88:AK:=301;
      89:AK:=277; 90:AK:=300; 48:AK:=385;
   else if (K >= 49) and (K <= 57) then
           AK := K + 327
        else
           AK := 0;
   end; {case}
   AltKey := AK;
end; {AltKey}
{|||||||||||||||||||||||||||||||||||||||||||||||||}
{                                                 }
{     A l p h a b e t O B J    M E T H O D S      }
{                                                 }
{|||||||||||||||||||||||||||||||||||||||||||||||||}
constructor AlphabetOBJ.Init;
{}
begin
   vUpper := ['A'..'Z'];
   vLower := ['a'..'z'];
   vPunctuation := [',',';',':','.',' '];
   AssignUpcaseFunc(EnglishUpcase);
   AssignLocaseFunc(EnglishLocase);
end; {AlphabetOBJ.Init}

procedure AlphabetOBJ.AssignUpCaseFunc(Func:caseFunc);
{}
begin
   vUpCaseFunc := Func;
end; {AlphabetOBJ.AssignUpCaseFunc}

procedure AlphabetOBJ.AssignLoCaseFunc(Func:caseFunc);
{}
begin
   vLoCaseFunc := Func;
end; {AlphabetOBJ.AssignLoCaseFunc}

procedure AlphabetOBJ.SetUpper(Letters:CharSet);
{}
begin
   vUpper := Letters;
end; {AlphabetOBJ.SetUpper}

procedure AlphabetOBJ.SetLower(Letters:CharSet);
{}
begin
   vLower := Letters;
end; {AlphabetOBJ.SetLower}

procedure AlphabetOBJ.SetPunctuation(Letters:CharSet);
{}
begin
   vPunctuation := Letters;
end; {AlphabetOBJ.SetPunctuation}

function AlphabetOBJ.IsUpper(K:word): boolean;
{}
begin
   if K > 255 then
     IsUpper := false
   else
     IsUpper := chr(K) in vUpper;
end; {AlphabetOBJ.IsUpper}

function AlphabetOBJ.IsLower(K:word): boolean;
{}
begin
   if K > 255 then
     IsLower := false
   else
     IsLower := chr(K) in vLower;
end; {AlphabetOBJ.IsLower}

function AlphabetOBJ.IsLetter(K:word): boolean;
{}
begin
   if K > 255 then
     IsLetter := false
   else
     IsLetter := (chr(K) in vUpper) or (chr(K) in vLower);
end; {AlphabetOBJ.IsLetter}

function AlphabetOBJ.IsPunctuation(K:word): boolean;
{}
begin
   if K > 255 then
     IsPunctuation := false
   else
   IsPunctuation := chr(K) in vPunctuation;
end; {AlphabetOBJ.IsPunctuation}

function AlphabetOBJ.GetUpCase(Ch:char):char;
{}
begin
   GetUpCase := vUpCaseFunc(Ch);
end; {AlphabetOBJ.GetUpCase}

function AlphabetOBJ.GetLoCase(Ch:char):char;
{}
begin
   GetLoCase := vLoCaseFunc(Ch);
end;{AlphabetOBJ.GetLoCase}

destructor AlphabetOBJ.Done;
{}
begin
end; {AlphabetOBJ.Done}
{|||||||||||||||||||||||||||||||||||||||||||}
{                                           }
{     M o u s e O B J    M E T H O D S      }
{                                           }
{|||||||||||||||||||||||||||||||||||||||||||}

{$IFDEF OS2}
function MouseThread( p: Pointer ): uLong;
const
  MouWait  : SmallWord = mou_Wait;
var
  MouEvent : MouEventInfo;
  Mouse : PMouseObj absolute P;

  procedure Press( Button : tButtons; X, Y : Word );
  begin
    with Mouse^ do
      begin
        Include( ButtonState, Button );
        mouMutex.Request;
        with PressCount do
          begin
            inc(Count[ord(Button)]);
            LastX := X;
            LastY := Y;
          end;
        mouMutex.Release;
      end;
  end;

  procedure Release( Button : tButtons; X, Y : Word );
  begin
    with Mouse^ do
      begin
        if Button in ButtonState then
          begin
            mouMutex.Request;
            with ReleaseCount do
              begin
                inc(Count[ord(Button)]);
                LastX := X;
                LastY := Y;
              end;
            mouMutex.Release;
          end;
        Exclude( ButtonState, Button );
      end;
  end;

Var
  NewPtr : PtrLoc;

begin
  with Mouse^, MouEvent do
    repeat
      MouReadEventQue( MouEvent, mouWait, mouHandle );

      // Check if mouse is outside allowed rectangle
      NewPtr.Col := $FFFF;
      NewPtr.Row := Row;
      if ( Col < ConfineX1 ) then
        NewPtr.Col := ConfineX1
      else if ( Col > ConfineX2 ) then
        NewPtr.Col := ConfineX2;

      if NewPtr.Row < ConfineY1 then
        begin
          if NewPtr.Col = $FFFF then
            NewPtr.Col := Col;
          NewPtr.Row := ConfineY1;
        end
      else if Row > ConfineY2 then
        begin
          if NewPtr.Col = $FFFF then
            NewPtr.Col := Col;
          NewPtr.Row := ConfineY2;
        end;

      // if not OK, set mouse position and ignore clicks etc
      if NewPtr.Col <> $FFFF then
        begin
          MouSetPtrPos( NewPtr, MouHandle );
          Col := NewPtr.Col;
          Row := NewPtr.Row;

          // Update mouse position
          MouX := succ(Col);
          MouY := succ(Row);
        end
      else
        begin
          // Update mouse position
          MouX := succ(Col);
          MouY := succ(Row);
          // Left mouse button (B1) status
          if (fs and (mouse_Motion_With_Bn1_Down or mouse_Bn1_Down)) <> 0 then
            Press( LeftButton, mouX, MouY )
          else
            Release( LeftButton, MouX, mouY );

         // Right mouse button (B2) status
         if (fs and (mouse_Motion_With_Bn2_Down or mouse_Bn2_Down)) <> 0 then
           Press( RightButton, mouX, MouY )
         else
           Release( RightButton, mouX, MouY );

         // Center mouse button (B3) status
         if (fs and (mouse_Motion_With_Bn3_Down or mouse_Bn3_Down)) <> 0 then
           Press( CenterButton, mouX, MouY )
         else
           Release( CenterButton, mouX, MouY );
        end;
    until False;
end;
{$ENDIF}

constructor MouseOBJ.Init;
{}
begin
  CheckInstalled;
  If vInstalled then
  begin
{$IFNDEF OS2}
     vIntr := $33;
     vVisible := false;
     Reset;
{$ENDIF}
  end
  else
     vVisible := false;
end; {MouseOBJ.Init}

procedure MouseOBJ.CheckInstalled;
{}
{$IFDEF OS2}
var
  rc: ApiRet;
  Temp: SmallWord;
  EventMask: SmallWord;
begin
  if MouHandle = 0 then
    begin
      Reset;
      vButtons := 0;
      MouGetNumButtons( Temp, mouHandle );
      vButtons := Temp;
      mouMutex := tMutexSem.Create;
      tid_Mouse := VPBeginThread( MouseThread, 16384, @Self );
    end;
  vInstalled := ( vButtons > 0 );
end;
{$ELSE}
var
  MouseInterruptPtr : pointer absolute $0000:$00CC;

    Function InterruptLoaded:boolean;
    var
      Reg: registers;
    begin
       Reg.Ax := 0;
       Intr($33,Reg);
       InterruptLoaded :=  Reg.Ax <> 0;
    end;

begin
   vButtons := 0;
   if (MouseInterruptPtr = nil)
   or (byte(MouseInterruptPtr) = $CF) then
      vInstalled := false          {don't call interrupt if vector is zero}
   else
      vInstalled := Interruptloaded;
end; {MouseOBJ.CheckInstalled}
{$ENDIF}

procedure MouseOBJ.Reset;
{$IFDEF OS2}
begin
  if mouHandle <> 0 then
    MouClose( mouHandle );
  if MouOpen( nil, mouHandle ) = 0 then
    begin
      ButtonState := [];
      fillChar(ReleaseCount,sizeof(ReleaseCount),0);
      fillChar(PressCount,sizeof(PressCount),0);

      ProtectArea.Row := 0;
      ProtectArea.Col := 0;
      ProtectArea.cRow := Hi(WindMax);
      ProtectArea.cCol := Lo(WindMax);
      ConfineX1 := 0;
      ConfineY1 := 0;
      ConfineX2 := Lo(WindMax);
      ConfineY2 := Hi(WindMax);
      vVisible := False;
    end;
end;
{$ELSE}
var Regs : registers;
begin
   if vInstalled then
   begin
      Regs.Ax := $00;
      Intr(vIntr,Regs);
      vButtons := Regs.Bx;
      vVisible := false;
   end;
end; {MouseOBJ.Reset}
{$ENDIF}

function MouseOBJ.Installed:boolean;
{}
begin
    Installed := vInstalled;
end; {MouseOBJ.Installed}

procedure MouseOBJ.Show;
{$IFDEF OS2}
begin
  if vInstalled and not vVisible then
    begin
      MouDrawPtr(Mouhandle);
      vVisible := True;
    end;
end;
{$ELSE}
var Regs : registers;
begin
   if (vInstalled) and (not vVisible) then
   begin
      Regs.Ax := $01;
      Intr(vIntr,Regs);
      vVisible := true;
   end;
end; {MouseOBJ.Show}
{$ENDIF}

procedure MouseOBJ.Hide;
{$IFDEF OS2}
begin
  if vInstalled and vVisible then
    begin
      MouRemovePtr(ProtectArea, Mouhandle);
      vVisible := True;
    end;
end;
{$ELSE}
var Regs : registers;
begin
   if vInstalled and vVisible then
   begin
      Regs.Ax := $02;
      Intr(vIntr,Regs);
      vVisible := false;
   end;
end; {MouseOBJ.Hide}
{$ENDIF}

procedure MouseOBJ.Move(X,Y : integer);
{X and Y are character positions not pixel positions}
{$IFDEF OS2}
Var
  PtrPos : PtrLoc;
begin
  if vInstalled then
    begin
      PtrPos.Row := pred(y);
      PtrPos.Col := pred(x);
      MouSetPtrPos( PtrPos, MouHandle );
    end;
end;
{$ELSE}
var Regs : registers;
begin
   if vInstalled then
   begin
      with Regs do
      begin
         Ax := $04;
         Cx := pred(X*8);   {8 pixels per character}
         Dx := pred(Y*8);   {         "-"          }
      end; {with}
      Intr(vIntr,Regs);
   end;
end; {MouseOBJ.Move}
{$ENDIF}

procedure MouseOBJ.Confine(X1,Y1,X2,Y2:integer);
{$IFDEF OS2}
begin
  if vInstalled then
    begin
      ConfineX1 := pred(X1);
      ConfineX2 := pred(X2);
      ConfineY1 := pred(Y1);
      ConfineY2 := pred(Y2);
    end;
end;
{$ELSE}
var Regs : registers;
begin
   if vInstalled then
      with Regs do
      begin
         {horizontal}
         Ax := $07;
         Cx := pred(X1*8);
         Dx := pred(X2*8);
         intr(vIntr,Regs);
         {vertical}
         Ax := $08;
         Cx := pred(Y1*8);
         Dx := pred(Y2*8);
         intr(vIntr,Regs);
      end;
end; {MouseOBJ.Confine}
{$ENDIF}

function MouseOBJ.Released(Button: integer; var X,Y: byte): byte;
{$IFDEF OS2}
begin
  if vInstalled then
    begin
      mouMutex.Request;
      with ReleaseCount do
        begin
          Released := Count[Button];
          Count[Button] := 0;
          X := LastX;
          Y := LastY;
        end;
      mouMutex.Release;
    end
  else
    Released := 0;
end;
{$ELSE}
var Regs : registers;
begin
   if vInstalled then
      with Regs do
      begin
         Ax := 6;
         Bx := Button;
         intr(vIntr,Regs);
         Released := Bx;
         X := succ(Cx div 8);
         Y := succ(Dx div 8);
      end;
end; {MouseOBJ.Released}
{$ENDIF}

function MouseOBJ.Pressed(Button: integer; var X,Y: byte): byte;
{$IFDEF OS2}
begin
  if vInstalled then
    begin
      mouMutex.Request;
      with PressCount do
        begin
          Pressed := Count[Button];
          Count[Button] := 0;
          X := LastX;
          Y := LastY;
        end;
      mouMutex.Release;
    end
  else
    Pressed := 0;
end;
{$ELSE}
var Regs : registers;
begin
   if vInstalled then
      with Regs do
      begin
         Ax := 5;
         Bx := Button;
         intr(vIntr,Regs);
         Pressed := Bx;
         X := succ(Cx div 8);
         Y := succ(Dx div 8);
      end;
end; {MouseOBJ.Pressed}
{$ENDIF}

function MouseOBJ.InZone(X1,Y1,X2,Y2: byte):boolean;
{}
var X,Y: byte;
begin
   if vInstalled and vVisible then
   begin
      Location(X,Y);
      InZone := (X >= X1) and (X <= X2) and (Y >= Y1) and (Y <= Y2);
   end
   else
      InZone := false;
end; {MouseOBJ.InZone}

procedure MouseOBJ.Location(var X,Y : byte);
{$IFDEF OS2}
begin
  if vInstalled then
    begin
      x := Succ(MouX);
      y := succ(MouY);
    end;
end;
{$ELSE}
var Regs : registers;
begin
   if vInstalled then
      with Regs do
      begin
         Ax := 3;
         intr(vIntr,Regs);
         X := succ(Cx div 8);
         Y := succ(Dx div 8);
      end; {with}
end; {MouseOBJ.Location}
{$ENDIF}

procedure MouseOBJ.Status(var L,C,R:boolean; var X,Y : byte);
{}
{$IFDEF OS2}
begin
  if vInstalled then
    begin
      X := MouX;
      Y := MouY;
      L := LeftButton in ButtonState;
      C := CenterButton in ButtonState;
      R := RightButton in ButtonState;
    end
  else
{$ELSE}
var Regs : registers;
begin
   if vInstalled then
   begin
      with Regs do
      begin
         Ax := 3;
         intr(vIntr,Regs);
         X := succ(Cx div 8);
         Y := succ(Dx div 8);
         L := ((BX and $01) = $01);
         R := ((BX and $02) = $02);
         C := ((BX and $04) = $04);
      end; {with}
   end
   else
{$ENDIF}
   begin
      L := false;
      C := false;
      R := false;
      X := 1;
      Y := 1;
   end;
end; {MouseOBJ.Status}

procedure MouseOBJ.WaitForRelease;  {1.10b}
{Waits for all mouse buttons to be released and clears the
 pressed history}
var
  L,M,R: boolean;
  X,Y,P: byte;
begin
   repeat
      Status(L,M,R,X,Y);
   until not L and not M and not R;
   P := Released(0,X,Y);
   P := Released(1,X,Y);
   if vButtons > 2 then
      P := Released(2,X,Y);
end; {MouseOBJ.WaitForRelease}

procedure MouseOBJ.SetMouseCursorStyle(OrdChar,Attr: byte);
{$IFDEF OS2}
Var
  Shape  : Array[1..2] of SmallWord;
  DefRec : PtrShape;

begin
  if vInstalled then
    begin
      Shape[1] := Attr;
      Shape[2] := OrdChar;
      DefRec.cb := 4;
      DefRec.Col := 1;
      DefRec.Row := 1;
      DefRec.ColHot := 0;
      DefRec.RowHot := 0;
      MouSetPtrShape( @Shape, DefRec, Mouhandle );
    end;
end;
{$ELSE}
var
  Reg: registers;
begin
   if vInstalled then
   begin
      Reg.Ax := 10;
      Reg.Bx := 0;        {software text cursor}
      if Attr = 0 then
         Reg.CX := $7700
      else
         Reg.Cx := $00;
      Reg.Dl := OrdChar;
      Reg.Dh := Attr;
      Intr($33,Reg);
   end;
end; {MouseOBJ.SetMouseCursorStyle}
{$ENDIF}

function MouseOBJ.Visible:boolean;
{}
begin
   Visible := vVisible;
end; {MouseOBJ.Visible}

function MouseOBJ.GetButtons: byte;
{}
begin
   GetButtons := vButtons;
end; {MouseOBJ.GetButtons}

procedure MouseOBJ.SetLeft(On:boolean);
{}
begin
   vLeftHanded := On;
end; {MouseOBJ.SetLeft}

destructor MouseOBJ.Done;
{}
begin
  {$IFDEF OS2}
  if mouhandle <> 0 then
    begin
      mouClose( mouHandle );
      mouMutex.Destroy;
    end;
  {$ENDIF}
end;
{|||||||||||||||||||||||||||||||||||||||}
{                                       }
{     K e y O B J    M e t h o d s      }
{                                       }
{|||||||||||||||||||||||||||||||||||||||}
constructor KeyOBJ.Init;
{}
{$IFDEF OS2}
var
  rc: ApiRet;
  KeyboardId : KbdHwId;
begin
   KeyboardID.cb := Sizeof(KeyboardID);
   rc := KbdGetHWId( KeyBoardID, 0 );
   vExtended := (KeyboardID.IdKbd = $AB41);
   vIdleHook := Os2IdleHook;
{$ELSE}
var
   ExtStatus: byte absolute $0000:$0496;
begin
   vExtended := (ExtStatus <> 0);
   vIdleHook := NoInputIdleHook;
{$ENDIF}
   vPressedHook := NoInputPressedHook;
   vBufferHead := 1;
   vBufferTail := 1;
   vHorizSensitivity := 1;
   vVertSensitivity := 1;
   vClick := false;
   vLastKey := 0;
   vWaitForDouble := false;
   vButtons := 0;
   SetMouseMethod(2);
end; {KeyOBJ.Init}

procedure KeyOBJ.AssignIdleHook(PassedProc: InputIdleProc);
{}
begin
   vIdleHook := PassedProc;
end; {KeyOBJ.AssignIdleHook}

procedure KeyOBJ.AssignPressedHook(PassedProc: InputPressedProc);
{}
begin
   vPressedHook := PassedProc;
end; {KeyOBJ.AssignPressedHook}

function KeyOBJ.Extended:boolean;
{}
begin
    Extended := vExtended;
end; {KeyOBJ.Extended}

procedure KeyOBJ.SetCaps(On:boolean);
{}
begin
{$IFDEF OS2}
   SetKeyboardState(kbdstf_CapsLock, On);
{$ELSE}
   If On then
      KeyStatusBits := (KeyStatusBits or $40)
   else
      KeyStatusBits := (KeyStatusBits and $BF);
{$ENDIF}
end; {KeyOBJ.SetCaps}

procedure KeyOBJ.SetNum(On:boolean);
{}
begin
{$IFDEF OS2}
   SetKeyboardState(kbdstf_NumLock, On);
{$ELSE}
   If On then
      KeyStatusBits := (KeyStatusBits or $20)
   else
      KeyStatusBits := (KeyStatusBits and $DF);
{$ENDIF}
end; {KeyOBJ.SetNum}

procedure KeyOBJ.SetScroll(On:boolean);
{}
begin
{$IFDEF OS2}
   SetKeyboardState(kbdstf_ScrollLock, On);
{$ELSE}
   If On then
      KeyStatusBits := (KeyStatusBits or $10)
   else
      KeyStatusBits := (KeyStatusBits and $EF);
{$ENDIF}
end; {KeyOBJ.SetScroll}

function KeyOBJ.GetCaps:boolean;
{}
var CapsOnW : word;
begin
{$IFDEF OS2}
   GetCaps := GetKeyboardState(kbdstf_CapsLock_On);
{$ELSE}
   CapsOnW := swap(KeyStatusBits);
   GetCaps := (CapsOnW and $4000) <> 0;
{$ENDIF}
end; {KeyOBJ.GetCaps}

function KeyOBJ.GetNum:boolean;
{}
var NumOnW : word;
begin
{$IFDEF OS2}
   GetNum := GetKeyboardState(kbdstf_NumLock_On);
{$ELSE}
   NumOnW := swap(KeyStatusBits);
   GetNum := (NumOnW and $2000) <> 0;
{$ENDIF}
end; {KeyOBJ.GetNum}

function KeyOBJ.GetScroll:boolean;
{}
var ScrollOnW : word;
begin
{$IFDEF OS2}
   GetScroll := GetKeyboardState(kbdstf_ScrollLock_On);
{$ELSE}
   ScrollOnW := swap(KeyStatusBits);
   GetScroll := (ScrollOnW and $1000) <> 0;
{$ENDIF}
end; {KeyOBJ.GetScroll}

procedure KeyOBJ.SetRepeatRate(Delay,Rate:byte);
{$IFDEF OS2}
var
  rc: ApiRet;
  Handle: hFile;
  Action: uLong;
  pSize: uShort;
  RateDelay : record
    Delay : SmallWord;
    Rate  : SmallWord;
  end;

begin
  rc := DosOpen( 'KBD$', Handle, Action, 0, 0, 1, $40, nil );

  if rc = 0 then
    begin
      pSize := Sizeof( RateDelay );
      RateDelay.Delay := pred(Delay);
      RateDelay.Rate  := $7FFF-Rate;
      rc := DosDevIOCtl( Handle,
                   ioctl_Keyboard,            // Category
                   kbd_SetTypaMaticRate,      // Function
                   @RateDelay, pSize, @pSize, // Parameters
                   nil, 0, nil );

      DosClose( Handle );
    end;
end;
{$ELSE}
var Regs : registers;
begin
  with Regs do
  begin
     Ah := 3;
     Al := 5;
     Bl := Rate;
     Bh := pred(Delay);
     Intr($16,Regs);
  end;
end; {KeyOBJ.SetRepeatRate}
{$ENDIF}

procedure KeyOBJ.SetFast;
{}
begin
   SetRepeatRate(1,0);
end; {KeyOBJ.SetFast}

procedure KeyOBJ.SetSlow;
{}
begin
   SetRepeatRate(2,$14);
end; {KeyOBJ.SetSlow}

procedure KeyOBJ.SetMouseMethod(Method:byte);
{}
begin
   if (Method in [1,2]) and Mouse.Installed then
   begin
      vMouseMethod := Method;
      vButtons := Mouse.GetButtons;
   end
   else
      vMouseMethod := 0;
end; {KeyOBJ.SetMouseMethod}

procedure KeyOBJ.SetHoriz(Sensitivity:byte);
{}
begin
   vHorizSensitivity := Sensitivity;
end; {KeyOBJ.SetHoriz}

procedure KeyOBJ.SetVert(Sensitivity:byte);
{}
begin
   vVertSensitivity := Sensitivity;
end; {KeyOBJ.SetHoriz}

procedure KeyOBJ.SetClick(On: boolean);
{}
begin
   vClick := On;
end; {KeyOBJ.SetClick}

procedure KeyOBJ.SetDouble(On:boolean);
{}
begin
   vWaitForDouble := On;
end; {KeyOBJ.SetDouble}

function KeyOBJ.GetDouble:boolean;
{}
begin
   GetDouble := vWaitForDouble;
end; {KeyOBJ.GetDouble}

procedure KeyOBJ.Click;
{}
begin
  {$IFDEF OS2}
   PlaySound( 1000, 1 );
   PlaySound( 50, 4 );
  {$ELSE}
   Sound(1000);
   Sound(50);
   delay(5);
   nosound;
  {$ENDIF}
end; {KeyOBJ.Click}

procedure KeyOBJ.GetInput;
{waits for a keypress or mouse activity}
Const
   H = 40;
   V = 13;
   SlowDelay = 350;    {was 200}
   QwikDelay = 20;
   LastPress: longint = 0;
   ClockTicks = 18.2;
Var
   L,C,R : boolean;
   Action: boolean;
   Finished: boolean;
   ThisPress: Longint;
   Temp, TempX,TempY,X,Y: byte;
   Ch : char;
   KeyWord : word;
   InitDelay:word;
   LeftPresses, RightPresses, CenterPresses: word;
   ButtonCombinations: byte;

begin
   if vWaitForDouble then
      InitDelay := SlowDelay
   else
      InitDelay := 100;
   if vBufferHead <> vBufferTail then  {read from object buffer}
   begin
      Keyword := vBuffer[vBufferHead];
      if vBufferHead < StuffBufferSize then
         Inc(vBufferHead)
      else
         vBufferHead := 1;
   end
   else       {wait for keypress or mouse action}
   begin
      if vMouseMethod = 1 then
         Mouse.Move(H,V);
      Action := false;
      Finished := false;
      repeat
         vIdleHook;   {call the users idle hook procedure}
         if vMouseMethod > 0 then
         begin
            {$IFDEF OS2}
            ThisPress := GetTimemSec;
            {$ELSE}
            ThisPress := MemL[$40:$6C];   {get time}
            {$ENDIF}
            Keyword := 0;
            Mouse.Status(L,C,R,X,Y);
            if L or R or C then {a button is being depressed}
            begin
               Finished := true;
               { Next is the mouse speed up effect }
               if ((ThisPress - LastPress) / ClockTicks)*1000 > InitDelay+200 then
               begin
                  delay(InitDelay);          {check for double click}
                  LeftPresses := Mouse.Released(0,TempX,TempY);
                  RightPresses := Mouse.Released(1,TempX,TempY);
                  if vButtons > 2 then
                     CenterPresses := Mouse.Released(2,TempX,TempY)
                  else
                     CenterPresses := 0;
                  {Check for mouse combinations}
                  ButtonCombinations :=   ord(LeftPresses > 0)
                                        + 2*ord(RightPresses > 0)
                                        + 4*ord(CenterPresses > 0);
                  case ButtonCombinations of
                     1: Keyword := 513;  {left button}
                     2: Keyword := 514;  {right button}
                     3: Keyword := 516;  {left+right}
                     4: Keyword := 515;  {center button}
                     5: Keyword := 517;  {left+center}
                     6: Keyword := 518;  {center+right}
                     7: Keyword := 519;  {all three buttons}
                  end;
                  if LeftPresses > 1 then
                     Keyword := 523      {double left}
                  else if RightPresses > 1 then
                     Keyword := 524      {double right}
                  else if CenterPresses > 1 then
                     Keyword := 525;     {double center}
               end
               else
                  delay(QwikDelay);
               LastPress := ThisPress;
               If Keyword = 0 then
               begin
                  if L then
                     Keyword := 513
                  else
                    if R then
                       Keyword := 514
                    else
                       Keyword := 515;
               end;
            end;
            Temp := Mouse.Pressed(0,TempX,TempY);   {clear the mouse buffers}
            Temp := Mouse.Pressed(1,TempX,TempY);
            Temp := Mouse.Pressed(2,TempX,TempY);
            Temp := Mouse.Released(0,TempX,TempY);
            Temp := Mouse.Released(1,TempX,TempY);
            Temp := Mouse.Released(2,TempX,TempY);
            if vMouseMethod = 1 then
            begin
               Mouse.Location(X,Y);
               if Y - V > vVertSensitivity then
               begin
                  Keyword :=  584;   {mouse up}
                  Finished := true;
               end
               else if V - Y > vVertSensitivity then
               begin
                  Keyword :=  592;   {mouse down}
                  Finished := true;
               end
               else if X - H > vHorizSensitivity then
               begin
                  Keyword :=  589;   {mouse right}
                  Finished := true;
               end
               else if H - X > vHorizSensitivity then
               begin
                  Keyword :=  587;   {mouse left}
                  Finished := true;
               end
            end;
         end; {if}
         If KeyPressed or Finished then
            Action := true;
      until Action;
      if not finished then
      begin
        Ch := ReadKey;
        if Ch = #0 then
        begin
            Ch := Readkey;
            Keyword := 256+ord(Ch);
            if (KeyWord >= 327) and (Keyword <= 339) then
            begin
               if AltPressed then
                  inc(Keyword,80)
               else if ShiftPressed then
                  inc(Keyword,100)
               else if CtrlPressed then
                  inc(Keyword,120);
            end;
        end
        else
           KeyWord := ord(Ch);
      end;

   end;
   vPressedHook(Keyword);
   vLastKey := Keyword;
   vLastX := X;
   vLastY := Y;
   if vClick then
      Click;
end; {KeyOBJ.GetInput}

function KeyOBJ.Lastkey: word;
{}
begin
   LastKey := vLastKey;
end; {KeyOBJ.Lastkey}

function KeyOBJ.GetKey: word;
{}
begin
   GetInput;
   GetKey := vLastKey;
end; {KeyOBJ.GetKey}

function KeyOBJ.LastChar: char;
{}
begin
   if vLastKey < 256 then
      LastChar := chr(LastKey)
   else
      LastChar := #0;
end; {KeyOBJ.LastChar}

function KeyOBJ.LastX: byte;
{}
begin
   LastX := vLastX;
end; {KeyOBJ.LastX}

function KeyOBJ.LastY: byte;
{}
begin
   LastY := vLastY;
end; {KeyOBJ.LastY}

procedure KeyOBJ.FlushBuffer;
{$IFDEF OS2}
begin
   KbdFlushBuffer( 0 );
end;
{$ELSE}
var Regs: registers;
begin
   vBufferTail := VBufferHead; {empty program buffer}
   with Regs do
   begin
      Ax := ($0c shl 8) or 6;
      Dx := $00ff;
   end;
   Intr($21,Regs);
end; {KeyOBJ.FlushBuffer}
{$ENDIF}

procedure KeyOBJ.StuffBuffer(W:word);
{adds word to program keyboard buffer}
begin
   if (vBufferTail + 1 = vBufferHead)
   or ((vBufferTail = StuffBufferSize) and (vBufferHead = 1)) then
      exit; {buffer full}
   vBuffer[vBufferTail] := W;
   if vBufferTail < StuffBufferSize then
      inc(vBufferTail)
   else
      vBufferTail := 1;
end; {KeyOBJ.StuffBuffer}

procedure KeyOBJ.StuffBufferStr(Str:string);
{}
var I,L : byte;
begin
   if Str <> '' then
   begin
      I := 1;
      L := length(Str);
      if L > StuffBufferSize then
         L := StuffBufferSize;
      while I <= L do
      begin
         StuffBuffer(ord(Str[I]));
         inc(I);
      end;
   end;
end; {KeyOBJ.StuffBufferStr}

function KeyOBJ.Keypressed: boolean;
{}
begin
   KeyPressed := (CRT.Keypressed) or (vBufferTail <> vBufferHead);
end; {KeyOBJ.KeyPressed}

procedure KeyOBJ.DelayKey(Mills:longint);
{}
var
  EndTime: longint;
  Now: longint;

   procedure SetNull;
   begin
      vLastKey := 0;
      vLastX := 0;
      vLastY := 0;
   end;

begin
   if Mills <= 0 then
      SetNull
   else
   begin
     {$IFDEF OS2}
      EndTime := GetTimemSec + trunc( (Mills/1000)*18.2);
      Repeat
         Now := GetTimemSec;
      until Keypressed or (Now >= EndTime);
     {$ELSE}
      EndTime := MemL[$40:$6C] + trunc( (Mills/1000)*18.2);
      Repeat
         Now := MemL[$40:$6C];
      until Keypressed or (Now >= EndTime);
     {$ENDIF}
      if KeyPressed then
         GetInput
      else
         SetNull;
   end;
end; {KeyOBJ.DelayKey}

function KeyOBJ.AltPressed:boolean;
{$IFDEF OS2}
begin
  AltPressed := GetKeyboardState(kbdstf_Alt);
{$ELSE}
var
  AltW : word;
begin
   AltW := swap(KeyStatusBits);
   AltPressed := (AltW and $0800) <> 0;
{$ENDIF}
end; {KeyOBJ.AltPressed}

function KeyOBJ.CtrlPressed:boolean;
{$IFDEF OS2}
begin
  CtrlPressed := GetKeyboardState(kbdstf_Control);
{$ELSE}
var
  CtrlW : word;
begin
   CtrlW := swap(KeyStatusBits);
   CtrlPressed := (CtrlW and $0400) <> 0;
{$ENDIF}
end; {KeyOBJ.CtrlPressed}

function KeyOBJ.LeftShiftPressed: boolean;
{$IFDEF OS2}
begin
  LeftShiftPressed := GetKeyboardState(kbdstf_LeftShift);
{$ELSE}
var LSW : word;
begin
   LSW := swap(KeyStatusBits);
   LeftShiftPressed := (LSW and $0200) <> 0;
{$ENDIF}
end; {LeftShiftPressed}

function KeyOBJ.RightShiftPressed: boolean;
{$IFDEF OS2}
begin
  RightShiftPressed := GetKeyboardState(kbdstf_RightShift);
{$ELSE}
var RSW : word;
begin
   RSW := swap(KeyStatusBits);
   RightShiftPressed := (RSW and $0100) <> 0;
{$ENDIF}
end; {RightShiftPressed}

function KeyOBJ.ShiftPressed: boolean;
{$IFDEF OS2}
begin
  ShiftPressed := GetKeyboardState(kbdstf_LeftShift or kbdstf_RightShift);
{$ELSE}
var SW : word;
begin
   SW := swap(KeyStatusBits);
   ShiftPressed := ((SW and $0200) <> 0) or ((SW and $0100) <> 0);
{$ENDIF}
end; {ShiftPressed}

destructor KeyOBJ.Done;
{}
begin end; {of desc KeyOBJ.Done}
{|||||||||||||||||||||||||||||||||||||||||||||||}
{                                               }
{     U N I T   I N I T I A L I Z A T I O N     }
{                                               }
{|||||||||||||||||||||||||||||||||||||||||||||||}
procedure InputInit;
{initilizes objects and global variables}
begin
   new(AlphabetTOT,Init);
   Mouse.Init;
   Key.Init;
end;

{end of unit - add intialization routines below}
{$IFNDEF OVERLAY}
begin
   InputInit;
{$ENDIF}
end.
